import { VueApolloQueryDefinition } from 'vue-apollo/types/options';
import { ApolloError, OperationVariables } from 'apollo-client';
import { DocumentNode } from 'graphql';
import { Vue } from 'vue/types/vue';
import { ApolloOperationErrorHandlerFunction } from './types';
export declare type VueApolloSmartQueryErrorHandler<TResult = any, TVariables = OperationVariables, TError = ApolloError, TApp extends Vue = Vue> = (error: TError, vm: TApp, key: string, type: 'query', options: VueApolloSmartQueryOptions<TResult, TVariables, TError, TApp>) => void;
export declare type VueApolloSmartQueryOptions<TResult = any, TVariables = OperationVariables, TError = ApolloError, TApp extends Vue = Vue> = Omit<VueApolloQueryDefinition<TResult, TVariables>, 'subscribeToMore' | 'error'> & {
    error?: VueApolloSmartQueryErrorHandler<TResult, TVariables, TError, TApp>;
};
export declare function createSmartQueryOptionsFunction<TResult, TVariables, TError = ApolloError, TApp extends Vue = Vue>(query: DocumentNode, onError?: ApolloOperationErrorHandlerFunction<TError, TApp>): (options?: Partial<VueApolloSmartQueryOptions<TResult, TVariables, TError, TApp>>) => VueApolloQueryDefinition<TResult, TVariables>;
